/*
 * Product Ordering
 *
 * **TMF API Reference : TMF 622 - Product Ordering Management**  **Release : 19.0 - June 2019**  The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.  The product order references the product offer and identifies any specific requests made by the customer.  **Product Order resource** A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.  Product Order API performs the following operations on product order :     -Retrieval of a product order or a collection of product orders depending on filter criteria     -Partial update of a product order (including updating rules)    -Creation of a product order (including default values and creation rules)    -Deletion of product order (for administration purposes)     -Notification of events on product order.  **cancelProductOrder resource** This resource is used to request a product order cancellation. Product Order API performs the following operations on product order :     -Retrieval of a cancel product order or a collection of cancel product orders     -Creation of a cancel product order     -Notification of events on cancel product order.   Copyright © TM Forum 2019. All Rights Reserved   
 *
 * API version: 4.0.0
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package openapi

import (
	"encoding/json"
	"time"
)

// ProductOrder A Product Order is a type of order which  can  be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa,
type ProductOrder struct {
	// ID created on repository side (OM system)
	Id *string `json:"id,omitempty"`
	// Hyperlink to access the order
	Href *string `json:"href,omitempty"`
	// Date when the order is cancelled. This is used when order is cancelled. 
	CancellationDate *time.Time `json:"cancellationDate,omitempty"`
	// Reason why the order is cancelled. This is used when order is cancelled. 
	CancellationReason *string `json:"cancellationReason,omitempty"`
	// Used to categorize the order from a business perspective that can be useful for the OM system (e.g. \"enterprise\", \"residential\", ...)
	Category *string `json:"category,omitempty"`
	// Date when the order was completed
	CompletionDate *time.Time `json:"completionDate,omitempty"`
	// Description of the product order
	Description *string `json:"description,omitempty"`
	// Expected delivery date amended by the provider
	ExpectedCompletionDate *time.Time `json:"expectedCompletionDate,omitempty"`
	// ID given by the consumer and only understandable by him (to facilitate his searches afterwards)
	ExternalId *string `json:"externalId,omitempty"`
	// Contact attached to the order to send back information regarding this order
	NotificationContact *string `json:"notificationContact,omitempty"`
	// Date when the order was created
	OrderDate *time.Time `json:"orderDate,omitempty"`
	// A way that can be used by consumers to prioritize orders in OM system (from 0 to 4 : 0 is the highest priority, and 4 the lowest)
	Priority *string `json:"priority,omitempty"`
	// Requested delivery date from the requestor perspective
	RequestedCompletionDate *time.Time `json:"requestedCompletionDate,omitempty"`
	// Order fulfillment start date wished by the requestor. This is used when, for any reason, requestor cannot allow seller to begin to operationally begin the fulfillment before a date. 
	RequestedStartDate *time.Time `json:"requestedStartDate,omitempty"`
	// A reference to an agreement defined in the context of the product order
	Agreement *[]AgreementRef `json:"agreement,omitempty"`
	BillingAccount *BillingAccountRef `json:"billingAccount,omitempty"`
	Channel *[]RelatedChannel `json:"channel,omitempty"`
	Note *[]Note `json:"note,omitempty"`
	OrderTotalPrice *[]OrderPrice `json:"orderTotalPrice,omitempty"`
	Payment *[]PaymentRef `json:"payment,omitempty"`
	ProductOfferingQualification *[]ProductOfferingQualificationRef `json:"productOfferingQualification,omitempty"`
	ProductOrderItem []ProductOrderItem `json:"productOrderItem"`
	Quote *[]QuoteRef `json:"quote,omitempty"`
	RelatedParty *[]RelatedParty `json:"relatedParty,omitempty"`
	State *ProductOrderStateType `json:"state,omitempty"`
	// When sub-classing, this defines the super-class
	BaseType *string `json:"@baseType,omitempty"`
	// A URI to a JSON-Schema file that defines additional attributes and relationships
	SchemaLocation *string `json:"@schemaLocation,omitempty"`
	// When sub-classing, this defines the sub-class entity name
	Type *string `json:"@type,omitempty"`
}

// NewProductOrder instantiates a new ProductOrder object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewProductOrder(productOrderItem []ProductOrderItem, ) *ProductOrder {
	this := ProductOrder{}
	this.ProductOrderItem = productOrderItem
	return &this
}

// NewProductOrderWithDefaults instantiates a new ProductOrder object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewProductOrderWithDefaults() *ProductOrder {
	this := ProductOrder{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *ProductOrder) GetId() string {
	if o == nil || o.Id == nil {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetIdOk() (*string, bool) {
	if o == nil || o.Id == nil {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *ProductOrder) HasId() bool {
	if o != nil && o.Id != nil {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *ProductOrder) SetId(v string) {
	o.Id = &v
}

// GetHref returns the Href field value if set, zero value otherwise.
func (o *ProductOrder) GetHref() string {
	if o == nil || o.Href == nil {
		var ret string
		return ret
	}
	return *o.Href
}

// GetHrefOk returns a tuple with the Href field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetHrefOk() (*string, bool) {
	if o == nil || o.Href == nil {
		return nil, false
	}
	return o.Href, true
}

// HasHref returns a boolean if a field has been set.
func (o *ProductOrder) HasHref() bool {
	if o != nil && o.Href != nil {
		return true
	}

	return false
}

// SetHref gets a reference to the given string and assigns it to the Href field.
func (o *ProductOrder) SetHref(v string) {
	o.Href = &v
}

// GetCancellationDate returns the CancellationDate field value if set, zero value otherwise.
func (o *ProductOrder) GetCancellationDate() time.Time {
	if o == nil || o.CancellationDate == nil {
		var ret time.Time
		return ret
	}
	return *o.CancellationDate
}

// GetCancellationDateOk returns a tuple with the CancellationDate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetCancellationDateOk() (*time.Time, bool) {
	if o == nil || o.CancellationDate == nil {
		return nil, false
	}
	return o.CancellationDate, true
}

// HasCancellationDate returns a boolean if a field has been set.
func (o *ProductOrder) HasCancellationDate() bool {
	if o != nil && o.CancellationDate != nil {
		return true
	}

	return false
}

// SetCancellationDate gets a reference to the given time.Time and assigns it to the CancellationDate field.
func (o *ProductOrder) SetCancellationDate(v time.Time) {
	o.CancellationDate = &v
}

// GetCancellationReason returns the CancellationReason field value if set, zero value otherwise.
func (o *ProductOrder) GetCancellationReason() string {
	if o == nil || o.CancellationReason == nil {
		var ret string
		return ret
	}
	return *o.CancellationReason
}

// GetCancellationReasonOk returns a tuple with the CancellationReason field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetCancellationReasonOk() (*string, bool) {
	if o == nil || o.CancellationReason == nil {
		return nil, false
	}
	return o.CancellationReason, true
}

// HasCancellationReason returns a boolean if a field has been set.
func (o *ProductOrder) HasCancellationReason() bool {
	if o != nil && o.CancellationReason != nil {
		return true
	}

	return false
}

// SetCancellationReason gets a reference to the given string and assigns it to the CancellationReason field.
func (o *ProductOrder) SetCancellationReason(v string) {
	o.CancellationReason = &v
}

// GetCategory returns the Category field value if set, zero value otherwise.
func (o *ProductOrder) GetCategory() string {
	if o == nil || o.Category == nil {
		var ret string
		return ret
	}
	return *o.Category
}

// GetCategoryOk returns a tuple with the Category field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetCategoryOk() (*string, bool) {
	if o == nil || o.Category == nil {
		return nil, false
	}
	return o.Category, true
}

// HasCategory returns a boolean if a field has been set.
func (o *ProductOrder) HasCategory() bool {
	if o != nil && o.Category != nil {
		return true
	}

	return false
}

// SetCategory gets a reference to the given string and assigns it to the Category field.
func (o *ProductOrder) SetCategory(v string) {
	o.Category = &v
}

// GetCompletionDate returns the CompletionDate field value if set, zero value otherwise.
func (o *ProductOrder) GetCompletionDate() time.Time {
	if o == nil || o.CompletionDate == nil {
		var ret time.Time
		return ret
	}
	return *o.CompletionDate
}

// GetCompletionDateOk returns a tuple with the CompletionDate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetCompletionDateOk() (*time.Time, bool) {
	if o == nil || o.CompletionDate == nil {
		return nil, false
	}
	return o.CompletionDate, true
}

// HasCompletionDate returns a boolean if a field has been set.
func (o *ProductOrder) HasCompletionDate() bool {
	if o != nil && o.CompletionDate != nil {
		return true
	}

	return false
}

// SetCompletionDate gets a reference to the given time.Time and assigns it to the CompletionDate field.
func (o *ProductOrder) SetCompletionDate(v time.Time) {
	o.CompletionDate = &v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *ProductOrder) GetDescription() string {
	if o == nil || o.Description == nil {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetDescriptionOk() (*string, bool) {
	if o == nil || o.Description == nil {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *ProductOrder) HasDescription() bool {
	if o != nil && o.Description != nil {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *ProductOrder) SetDescription(v string) {
	o.Description = &v
}

// GetExpectedCompletionDate returns the ExpectedCompletionDate field value if set, zero value otherwise.
func (o *ProductOrder) GetExpectedCompletionDate() time.Time {
	if o == nil || o.ExpectedCompletionDate == nil {
		var ret time.Time
		return ret
	}
	return *o.ExpectedCompletionDate
}

// GetExpectedCompletionDateOk returns a tuple with the ExpectedCompletionDate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetExpectedCompletionDateOk() (*time.Time, bool) {
	if o == nil || o.ExpectedCompletionDate == nil {
		return nil, false
	}
	return o.ExpectedCompletionDate, true
}

// HasExpectedCompletionDate returns a boolean if a field has been set.
func (o *ProductOrder) HasExpectedCompletionDate() bool {
	if o != nil && o.ExpectedCompletionDate != nil {
		return true
	}

	return false
}

// SetExpectedCompletionDate gets a reference to the given time.Time and assigns it to the ExpectedCompletionDate field.
func (o *ProductOrder) SetExpectedCompletionDate(v time.Time) {
	o.ExpectedCompletionDate = &v
}

// GetExternalId returns the ExternalId field value if set, zero value otherwise.
func (o *ProductOrder) GetExternalId() string {
	if o == nil || o.ExternalId == nil {
		var ret string
		return ret
	}
	return *o.ExternalId
}

// GetExternalIdOk returns a tuple with the ExternalId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetExternalIdOk() (*string, bool) {
	if o == nil || o.ExternalId == nil {
		return nil, false
	}
	return o.ExternalId, true
}

// HasExternalId returns a boolean if a field has been set.
func (o *ProductOrder) HasExternalId() bool {
	if o != nil && o.ExternalId != nil {
		return true
	}

	return false
}

// SetExternalId gets a reference to the given string and assigns it to the ExternalId field.
func (o *ProductOrder) SetExternalId(v string) {
	o.ExternalId = &v
}

// GetNotificationContact returns the NotificationContact field value if set, zero value otherwise.
func (o *ProductOrder) GetNotificationContact() string {
	if o == nil || o.NotificationContact == nil {
		var ret string
		return ret
	}
	return *o.NotificationContact
}

// GetNotificationContactOk returns a tuple with the NotificationContact field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetNotificationContactOk() (*string, bool) {
	if o == nil || o.NotificationContact == nil {
		return nil, false
	}
	return o.NotificationContact, true
}

// HasNotificationContact returns a boolean if a field has been set.
func (o *ProductOrder) HasNotificationContact() bool {
	if o != nil && o.NotificationContact != nil {
		return true
	}

	return false
}

// SetNotificationContact gets a reference to the given string and assigns it to the NotificationContact field.
func (o *ProductOrder) SetNotificationContact(v string) {
	o.NotificationContact = &v
}

// GetOrderDate returns the OrderDate field value if set, zero value otherwise.
func (o *ProductOrder) GetOrderDate() time.Time {
	if o == nil || o.OrderDate == nil {
		var ret time.Time
		return ret
	}
	return *o.OrderDate
}

// GetOrderDateOk returns a tuple with the OrderDate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetOrderDateOk() (*time.Time, bool) {
	if o == nil || o.OrderDate == nil {
		return nil, false
	}
	return o.OrderDate, true
}

// HasOrderDate returns a boolean if a field has been set.
func (o *ProductOrder) HasOrderDate() bool {
	if o != nil && o.OrderDate != nil {
		return true
	}

	return false
}

// SetOrderDate gets a reference to the given time.Time and assigns it to the OrderDate field.
func (o *ProductOrder) SetOrderDate(v time.Time) {
	o.OrderDate = &v
}

// GetPriority returns the Priority field value if set, zero value otherwise.
func (o *ProductOrder) GetPriority() string {
	if o == nil || o.Priority == nil {
		var ret string
		return ret
	}
	return *o.Priority
}

// GetPriorityOk returns a tuple with the Priority field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetPriorityOk() (*string, bool) {
	if o == nil || o.Priority == nil {
		return nil, false
	}
	return o.Priority, true
}

// HasPriority returns a boolean if a field has been set.
func (o *ProductOrder) HasPriority() bool {
	if o != nil && o.Priority != nil {
		return true
	}

	return false
}

// SetPriority gets a reference to the given string and assigns it to the Priority field.
func (o *ProductOrder) SetPriority(v string) {
	o.Priority = &v
}

// GetRequestedCompletionDate returns the RequestedCompletionDate field value if set, zero value otherwise.
func (o *ProductOrder) GetRequestedCompletionDate() time.Time {
	if o == nil || o.RequestedCompletionDate == nil {
		var ret time.Time
		return ret
	}
	return *o.RequestedCompletionDate
}

// GetRequestedCompletionDateOk returns a tuple with the RequestedCompletionDate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetRequestedCompletionDateOk() (*time.Time, bool) {
	if o == nil || o.RequestedCompletionDate == nil {
		return nil, false
	}
	return o.RequestedCompletionDate, true
}

// HasRequestedCompletionDate returns a boolean if a field has been set.
func (o *ProductOrder) HasRequestedCompletionDate() bool {
	if o != nil && o.RequestedCompletionDate != nil {
		return true
	}

	return false
}

// SetRequestedCompletionDate gets a reference to the given time.Time and assigns it to the RequestedCompletionDate field.
func (o *ProductOrder) SetRequestedCompletionDate(v time.Time) {
	o.RequestedCompletionDate = &v
}

// GetRequestedStartDate returns the RequestedStartDate field value if set, zero value otherwise.
func (o *ProductOrder) GetRequestedStartDate() time.Time {
	if o == nil || o.RequestedStartDate == nil {
		var ret time.Time
		return ret
	}
	return *o.RequestedStartDate
}

// GetRequestedStartDateOk returns a tuple with the RequestedStartDate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetRequestedStartDateOk() (*time.Time, bool) {
	if o == nil || o.RequestedStartDate == nil {
		return nil, false
	}
	return o.RequestedStartDate, true
}

// HasRequestedStartDate returns a boolean if a field has been set.
func (o *ProductOrder) HasRequestedStartDate() bool {
	if o != nil && o.RequestedStartDate != nil {
		return true
	}

	return false
}

// SetRequestedStartDate gets a reference to the given time.Time and assigns it to the RequestedStartDate field.
func (o *ProductOrder) SetRequestedStartDate(v time.Time) {
	o.RequestedStartDate = &v
}

// GetAgreement returns the Agreement field value if set, zero value otherwise.
func (o *ProductOrder) GetAgreement() []AgreementRef {
	if o == nil || o.Agreement == nil {
		var ret []AgreementRef
		return ret
	}
	return *o.Agreement
}

// GetAgreementOk returns a tuple with the Agreement field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetAgreementOk() (*[]AgreementRef, bool) {
	if o == nil || o.Agreement == nil {
		return nil, false
	}
	return o.Agreement, true
}

// HasAgreement returns a boolean if a field has been set.
func (o *ProductOrder) HasAgreement() bool {
	if o != nil && o.Agreement != nil {
		return true
	}

	return false
}

// SetAgreement gets a reference to the given []AgreementRef and assigns it to the Agreement field.
func (o *ProductOrder) SetAgreement(v []AgreementRef) {
	o.Agreement = &v
}

// GetBillingAccount returns the BillingAccount field value if set, zero value otherwise.
func (o *ProductOrder) GetBillingAccount() BillingAccountRef {
	if o == nil || o.BillingAccount == nil {
		var ret BillingAccountRef
		return ret
	}
	return *o.BillingAccount
}

// GetBillingAccountOk returns a tuple with the BillingAccount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetBillingAccountOk() (*BillingAccountRef, bool) {
	if o == nil || o.BillingAccount == nil {
		return nil, false
	}
	return o.BillingAccount, true
}

// HasBillingAccount returns a boolean if a field has been set.
func (o *ProductOrder) HasBillingAccount() bool {
	if o != nil && o.BillingAccount != nil {
		return true
	}

	return false
}

// SetBillingAccount gets a reference to the given BillingAccountRef and assigns it to the BillingAccount field.
func (o *ProductOrder) SetBillingAccount(v BillingAccountRef) {
	o.BillingAccount = &v
}

// GetChannel returns the Channel field value if set, zero value otherwise.
func (o *ProductOrder) GetChannel() []RelatedChannel {
	if o == nil || o.Channel == nil {
		var ret []RelatedChannel
		return ret
	}
	return *o.Channel
}

// GetChannelOk returns a tuple with the Channel field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetChannelOk() (*[]RelatedChannel, bool) {
	if o == nil || o.Channel == nil {
		return nil, false
	}
	return o.Channel, true
}

// HasChannel returns a boolean if a field has been set.
func (o *ProductOrder) HasChannel() bool {
	if o != nil && o.Channel != nil {
		return true
	}

	return false
}

// SetChannel gets a reference to the given []RelatedChannel and assigns it to the Channel field.
func (o *ProductOrder) SetChannel(v []RelatedChannel) {
	o.Channel = &v
}

// GetNote returns the Note field value if set, zero value otherwise.
func (o *ProductOrder) GetNote() []Note {
	if o == nil || o.Note == nil {
		var ret []Note
		return ret
	}
	return *o.Note
}

// GetNoteOk returns a tuple with the Note field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetNoteOk() (*[]Note, bool) {
	if o == nil || o.Note == nil {
		return nil, false
	}
	return o.Note, true
}

// HasNote returns a boolean if a field has been set.
func (o *ProductOrder) HasNote() bool {
	if o != nil && o.Note != nil {
		return true
	}

	return false
}

// SetNote gets a reference to the given []Note and assigns it to the Note field.
func (o *ProductOrder) SetNote(v []Note) {
	o.Note = &v
}

// GetOrderTotalPrice returns the OrderTotalPrice field value if set, zero value otherwise.
func (o *ProductOrder) GetOrderTotalPrice() []OrderPrice {
	if o == nil || o.OrderTotalPrice == nil {
		var ret []OrderPrice
		return ret
	}
	return *o.OrderTotalPrice
}

// GetOrderTotalPriceOk returns a tuple with the OrderTotalPrice field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetOrderTotalPriceOk() (*[]OrderPrice, bool) {
	if o == nil || o.OrderTotalPrice == nil {
		return nil, false
	}
	return o.OrderTotalPrice, true
}

// HasOrderTotalPrice returns a boolean if a field has been set.
func (o *ProductOrder) HasOrderTotalPrice() bool {
	if o != nil && o.OrderTotalPrice != nil {
		return true
	}

	return false
}

// SetOrderTotalPrice gets a reference to the given []OrderPrice and assigns it to the OrderTotalPrice field.
func (o *ProductOrder) SetOrderTotalPrice(v []OrderPrice) {
	o.OrderTotalPrice = &v
}

// GetPayment returns the Payment field value if set, zero value otherwise.
func (o *ProductOrder) GetPayment() []PaymentRef {
	if o == nil || o.Payment == nil {
		var ret []PaymentRef
		return ret
	}
	return *o.Payment
}

// GetPaymentOk returns a tuple with the Payment field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetPaymentOk() (*[]PaymentRef, bool) {
	if o == nil || o.Payment == nil {
		return nil, false
	}
	return o.Payment, true
}

// HasPayment returns a boolean if a field has been set.
func (o *ProductOrder) HasPayment() bool {
	if o != nil && o.Payment != nil {
		return true
	}

	return false
}

// SetPayment gets a reference to the given []PaymentRef and assigns it to the Payment field.
func (o *ProductOrder) SetPayment(v []PaymentRef) {
	o.Payment = &v
}

// GetProductOfferingQualification returns the ProductOfferingQualification field value if set, zero value otherwise.
func (o *ProductOrder) GetProductOfferingQualification() []ProductOfferingQualificationRef {
	if o == nil || o.ProductOfferingQualification == nil {
		var ret []ProductOfferingQualificationRef
		return ret
	}
	return *o.ProductOfferingQualification
}

// GetProductOfferingQualificationOk returns a tuple with the ProductOfferingQualification field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetProductOfferingQualificationOk() (*[]ProductOfferingQualificationRef, bool) {
	if o == nil || o.ProductOfferingQualification == nil {
		return nil, false
	}
	return o.ProductOfferingQualification, true
}

// HasProductOfferingQualification returns a boolean if a field has been set.
func (o *ProductOrder) HasProductOfferingQualification() bool {
	if o != nil && o.ProductOfferingQualification != nil {
		return true
	}

	return false
}

// SetProductOfferingQualification gets a reference to the given []ProductOfferingQualificationRef and assigns it to the ProductOfferingQualification field.
func (o *ProductOrder) SetProductOfferingQualification(v []ProductOfferingQualificationRef) {
	o.ProductOfferingQualification = &v
}

// GetProductOrderItem returns the ProductOrderItem field value
func (o *ProductOrder) GetProductOrderItem() []ProductOrderItem {
	if o == nil  {
		var ret []ProductOrderItem
		return ret
	}

	return o.ProductOrderItem
}

// GetProductOrderItemOk returns a tuple with the ProductOrderItem field value
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetProductOrderItemOk() (*[]ProductOrderItem, bool) {
	if o == nil  {
		return nil, false
	}
	return &o.ProductOrderItem, true
}

// SetProductOrderItem sets field value
func (o *ProductOrder) SetProductOrderItem(v []ProductOrderItem) {
	o.ProductOrderItem = v
}

// GetQuote returns the Quote field value if set, zero value otherwise.
func (o *ProductOrder) GetQuote() []QuoteRef {
	if o == nil || o.Quote == nil {
		var ret []QuoteRef
		return ret
	}
	return *o.Quote
}

// GetQuoteOk returns a tuple with the Quote field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetQuoteOk() (*[]QuoteRef, bool) {
	if o == nil || o.Quote == nil {
		return nil, false
	}
	return o.Quote, true
}

// HasQuote returns a boolean if a field has been set.
func (o *ProductOrder) HasQuote() bool {
	if o != nil && o.Quote != nil {
		return true
	}

	return false
}

// SetQuote gets a reference to the given []QuoteRef and assigns it to the Quote field.
func (o *ProductOrder) SetQuote(v []QuoteRef) {
	o.Quote = &v
}

// GetRelatedParty returns the RelatedParty field value if set, zero value otherwise.
func (o *ProductOrder) GetRelatedParty() []RelatedParty {
	if o == nil || o.RelatedParty == nil {
		var ret []RelatedParty
		return ret
	}
	return *o.RelatedParty
}

// GetRelatedPartyOk returns a tuple with the RelatedParty field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetRelatedPartyOk() (*[]RelatedParty, bool) {
	if o == nil || o.RelatedParty == nil {
		return nil, false
	}
	return o.RelatedParty, true
}

// HasRelatedParty returns a boolean if a field has been set.
func (o *ProductOrder) HasRelatedParty() bool {
	if o != nil && o.RelatedParty != nil {
		return true
	}

	return false
}

// SetRelatedParty gets a reference to the given []RelatedParty and assigns it to the RelatedParty field.
func (o *ProductOrder) SetRelatedParty(v []RelatedParty) {
	o.RelatedParty = &v
}

// GetState returns the State field value if set, zero value otherwise.
func (o *ProductOrder) GetState() ProductOrderStateType {
	if o == nil || o.State == nil {
		var ret ProductOrderStateType
		return ret
	}
	return *o.State
}

// GetStateOk returns a tuple with the State field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetStateOk() (*ProductOrderStateType, bool) {
	if o == nil || o.State == nil {
		return nil, false
	}
	return o.State, true
}

// HasState returns a boolean if a field has been set.
func (o *ProductOrder) HasState() bool {
	if o != nil && o.State != nil {
		return true
	}

	return false
}

// SetState gets a reference to the given ProductOrderStateType and assigns it to the State field.
func (o *ProductOrder) SetState(v ProductOrderStateType) {
	o.State = &v
}

// GetBaseType returns the BaseType field value if set, zero value otherwise.
func (o *ProductOrder) GetBaseType() string {
	if o == nil || o.BaseType == nil {
		var ret string
		return ret
	}
	return *o.BaseType
}

// GetBaseTypeOk returns a tuple with the BaseType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetBaseTypeOk() (*string, bool) {
	if o == nil || o.BaseType == nil {
		return nil, false
	}
	return o.BaseType, true
}

// HasBaseType returns a boolean if a field has been set.
func (o *ProductOrder) HasBaseType() bool {
	if o != nil && o.BaseType != nil {
		return true
	}

	return false
}

// SetBaseType gets a reference to the given string and assigns it to the BaseType field.
func (o *ProductOrder) SetBaseType(v string) {
	o.BaseType = &v
}

// GetSchemaLocation returns the SchemaLocation field value if set, zero value otherwise.
func (o *ProductOrder) GetSchemaLocation() string {
	if o == nil || o.SchemaLocation == nil {
		var ret string
		return ret
	}
	return *o.SchemaLocation
}

// GetSchemaLocationOk returns a tuple with the SchemaLocation field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetSchemaLocationOk() (*string, bool) {
	if o == nil || o.SchemaLocation == nil {
		return nil, false
	}
	return o.SchemaLocation, true
}

// HasSchemaLocation returns a boolean if a field has been set.
func (o *ProductOrder) HasSchemaLocation() bool {
	if o != nil && o.SchemaLocation != nil {
		return true
	}

	return false
}

// SetSchemaLocation gets a reference to the given string and assigns it to the SchemaLocation field.
func (o *ProductOrder) SetSchemaLocation(v string) {
	o.SchemaLocation = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *ProductOrder) GetType() string {
	if o == nil || o.Type == nil {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrder) GetTypeOk() (*string, bool) {
	if o == nil || o.Type == nil {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *ProductOrder) HasType() bool {
	if o != nil && o.Type != nil {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *ProductOrder) SetType(v string) {
	o.Type = &v
}

func (o ProductOrder) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Id != nil {
		toSerialize["id"] = o.Id
	}
	if o.Href != nil {
		toSerialize["href"] = o.Href
	}
	if o.CancellationDate != nil {
		toSerialize["cancellationDate"] = o.CancellationDate
	}
	if o.CancellationReason != nil {
		toSerialize["cancellationReason"] = o.CancellationReason
	}
	if o.Category != nil {
		toSerialize["category"] = o.Category
	}
	if o.CompletionDate != nil {
		toSerialize["completionDate"] = o.CompletionDate
	}
	if o.Description != nil {
		toSerialize["description"] = o.Description
	}
	if o.ExpectedCompletionDate != nil {
		toSerialize["expectedCompletionDate"] = o.ExpectedCompletionDate
	}
	if o.ExternalId != nil {
		toSerialize["externalId"] = o.ExternalId
	}
	if o.NotificationContact != nil {
		toSerialize["notificationContact"] = o.NotificationContact
	}
	if o.OrderDate != nil {
		toSerialize["orderDate"] = o.OrderDate
	}
	if o.Priority != nil {
		toSerialize["priority"] = o.Priority
	}
	if o.RequestedCompletionDate != nil {
		toSerialize["requestedCompletionDate"] = o.RequestedCompletionDate
	}
	if o.RequestedStartDate != nil {
		toSerialize["requestedStartDate"] = o.RequestedStartDate
	}
	if o.Agreement != nil {
		toSerialize["agreement"] = o.Agreement
	}
	if o.BillingAccount != nil {
		toSerialize["billingAccount"] = o.BillingAccount
	}
	if o.Channel != nil {
		toSerialize["channel"] = o.Channel
	}
	if o.Note != nil {
		toSerialize["note"] = o.Note
	}
	if o.OrderTotalPrice != nil {
		toSerialize["orderTotalPrice"] = o.OrderTotalPrice
	}
	if o.Payment != nil {
		toSerialize["payment"] = o.Payment
	}
	if o.ProductOfferingQualification != nil {
		toSerialize["productOfferingQualification"] = o.ProductOfferingQualification
	}
	if true {
		toSerialize["productOrderItem"] = o.ProductOrderItem
	}
	if o.Quote != nil {
		toSerialize["quote"] = o.Quote
	}
	if o.RelatedParty != nil {
		toSerialize["relatedParty"] = o.RelatedParty
	}
	if o.State != nil {
		toSerialize["state"] = o.State
	}
	if o.BaseType != nil {
		toSerialize["@baseType"] = o.BaseType
	}
	if o.SchemaLocation != nil {
		toSerialize["@schemaLocation"] = o.SchemaLocation
	}
	if o.Type != nil {
		toSerialize["@type"] = o.Type
	}
	return json.Marshal(toSerialize)
}

type NullableProductOrder struct {
	value *ProductOrder
	isSet bool
}

func (v NullableProductOrder) Get() *ProductOrder {
	return v.value
}

func (v *NullableProductOrder) Set(val *ProductOrder) {
	v.value = val
	v.isSet = true
}

func (v NullableProductOrder) IsSet() bool {
	return v.isSet
}

func (v *NullableProductOrder) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableProductOrder(val *ProductOrder) *NullableProductOrder {
	return &NullableProductOrder{value: val, isSet: true}
}

func (v NullableProductOrder) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableProductOrder) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


